# Roolfs, 2017

from tkinter import *
from math import *
from random import *
from copy import *
import time


m=35  #  Die Anzahl der zufälligen Knoten kann verändert werden.
      #  Es wird versucht, die Weglänge zu verringern.
      #  Das kann einige Zeit dauern.
      #  Das Programm bricht nicht von selbst ab.
      #  Die minimale Weglänge wird nicht garantiert.
      
fenster = Tk()
flaeche = Canvas(fenster, width=1100, height=750, bg='gray')
flaeche.pack()

def circle(x,y,r):
 flaeche.create_oval(x-r,y-r,x+r,y+r,fill="white", outline="blue")

class punkt:
  def __init__(self,x,y):
    self.x=x
    self.y=y
  def plotten(self):
     circle(self.x,self.y,5)
     
punkteliste=[]
for n in range(m):                             # Liste mit zufälligen Knoten
   punkteliste.append(punkt(randint(50,850),randint(50,700)) )


def abstand(punkteliste,i,j):                  # Abstand zweier Knoten
   return sqrt(
           (punkteliste[i].x - punkteliste[j].x)**2 +
           (punkteliste[i].y - punkteliste[j].y)**2
           )

def laenge(punkteliste):                       # Gesamtweglänge
  summe=0                              
  for n in range(m):
     summe=summe+abstand(punkteliste,n,(n+1)%m)
  return summe

def det(a,b,c,d):                              # Determinante zur Ermittlung von Überschneidungen
   return a*d-b*c

def Graphik():
  for n in range(m):
     punkteliste[n].plotten()     
     flaeche.create_text(punkteliste[n].x+15, punkteliste[n].y+5 , font=("Arial", 10),text=n)    
                                                #  Knotennummerierung
                                           
     flaeche.create_line(punkteliste[n].x, punkteliste[n].y, punkteliste[(n+1)%m].x,
          punkteliste[(n+1)%m].y, fill="white", width=1)
                                                #  Streckenzug    
  time.sleep(0)
  flaeche.update( )
  flaeche.delete(ALL)


u=0                                             #  while-Schleifen-Zähler
min=laenge(punkteliste)
min_a=1
punkteliste4=copy(punkteliste)

while True:    
  if u%100==0 and min_a != min:                 #  Anzahl der Ausgaben wird begrenzt
     min_a=min  
     print(min)     
     Graphik() 
    
  u=u+1                                     
  punkteliste.append(punkteliste[0])            #  Listenanfang wird verändert, Liste wird zyklisch vertauscht
  del punkteliste[0]

  if u%m==0:
    punkteliste.reverse()   
    
  punkteliste2=copy(punkteliste)                #  zufälliges Vertauschen von aufeinanderfolgenden Knoten
  i =randint(0,m-1)
  k=punkteliste2[i]
  punkteliste2[i]=punkteliste2[(i+1)%m]
  punkteliste2[(i+1)%m]=k
  L=laenge(punkteliste2)

  if L<min:                                     #  neue Knotenliste, falls sich die Weglänge verringert hat
     min=L
     punkteliste=copy(punkteliste2)     
   
     
  punkteliste2=copy(punkteliste)     
  i =randint(0,m-2)
  distanz_min=100000
  stelle=2
  for q in range(i+1,m):                        #  nächstgelegener Knoten soll berücksichtigt werden
       distanz=abstand(punkteliste2,i,q)

       if distanz < distanz_min:
             distanz_min=distanz
             stelle=q             
  k=punkteliste2[i]
  punkteliste2.remove(k)  
  punkteliste2.insert(stelle+2, k)  
    
  L2=laenge(punkteliste2)
  if L2 < min:        
        min=L2 
        punkteliste=copy(punkteliste2)
  else:
       punkteliste2.remove(k)  
       punkteliste2.insert(stelle-2, k)
       L2=laenge(punkteliste2)
       if L2 < min:        
            min=L2            
            punkteliste=copy(punkteliste2)   


  punkteliste2=copy(punkteliste)     
  i =randint(1,m-4)
  distanz_min=100000
  stelle=2
  for q in range(i+2,m-2):                       #  nächstgelegene 2 Knoten sollen berücksichtigt werden
       distanz=abstand(punkteliste2,i,q)

       if distanz < distanz_min:
             distanz_min=distanz
             stelle=q             
  k1=punkteliste2[i]
  k2=punkteliste2[i+1]
  punkteliste2.remove(k1)
  punkteliste2.remove(k2)  
  punkteliste2.insert(stelle+3, k1)
  punkteliste2.insert((stelle+4)%m, k2)  
    
  L2=laenge(punkteliste2)
  if L2 < min:
        min=L2 
        punkteliste=copy(punkteliste2)
  else:
      punkteliste2=copy(punkteliste)
      punkteliste2.remove(k1)
      punkteliste2.remove(k2)  
      punkteliste2.insert(stelle-3, k1)
      punkteliste2.insert(stelle-4, k2)
      L2=laenge(punkteliste2)
      if L2 < min:
        min=L2 
        punkteliste=copy(punkteliste2)
      
  
  punkteliste2=copy(punkteliste)                #  zufälliges Vertauschen von Knoten
  anz=randint(2,5)
  for i in range(1,anz):
      [i,j] =[randint(0,m-1),randint(0,m-1)]
      if i!=j:
           k=punkteliste2[i]
           punkteliste2[i]=punkteliste2[j]
           punkteliste2[j]=k
           L=laenge(punkteliste2)
           if L<min:
             min=L
             punkteliste=copy(punkteliste2)             
           
    

  if u > m**1.5 :
   punkteliste2=copy(punkteliste)   
   i =randint(0,m-3)                            #  Überschneidungen sollen aufgehoben werden
    
   for q in range(i+1,m):
    (ix,iy,i1x,i1y,jx,jy,j1x,j1y)=(punkteliste2[i].x,punkteliste2[i].y,
          punkteliste2[i+1].x,punkteliste2[i+1].y,
          punkteliste2[q].x,punkteliste2[q].y,
          punkteliste2[(q+1)%m].x,punkteliste2[(q+1)%m].y)
    d=det((i1x-ix),(i1y-iy),(j1x-jx),(j1y-jy))  #  Das Gleichungssystem für den Schnitt von Geraden
    if d != 0:                                  #  wird mit Determinanten gelöst.
        r=det((jx-ix),(jy-iy),(j1x-jx),(j1y-jy))/d 
        s=det((i1x-ix),(i1y-iy),(jx-ix),(jy-iy))/d 
        if r<1 and 0<r and s<0 and -1<s :       #  notwendige Bedingung für eine Überschneidung
             
           a1=abstand(punkteliste2,i,q) + abstand(punkteliste2,(q+1)%m,i+1)
           a2=abstand(punkteliste2,(q+1)%m,q) + abstand(punkteliste2,i,i+1)
           if a1 < a2:
             k=punkteliste2[q]
             punkteliste2[q]=punkteliste2[i+1]
             punkteliste2[i+1]=k
             zwischenpunkte=punkteliste2[(i+2):(q-1)]
             zwischenpunkte.reverse()                        
             min=L-a2+a1                             
             punkteliste=copy(punkteliste2)
             
